## juju-core 2.3.7

=== src/github.com/juju/ansiterm/Makefile ===
# Copyright 2016 Canonical Ltd.
# Licensed under the LGPLv3, see LICENCE file for details.

default: check

check:
	go test

docs:
	godoc2md github.com/juju/ansiterm > README.md
	sed -i 's|\[godoc-link-here\]|[![GoDoc](https://godoc.org/github.com/juju/ansiterm?status.svg)](https://godoc.org/github.com/juju/ansiterm)|' README.md 


.PHONY: default check docs

=== src/github.com/juju/bundlechanges/Makefile ===
# Makefile for the bundlechanges library.

PROJECT := github.com/juju/bundlechanges
PROJECT_DIR := $(shell go list -e -f '{{.Dir}}' $(PROJECT))

ifeq ($(shell uname -p | sed -r 's/.*(x86|armel|armhf).*/golang/'), golang)
	GO_C := golang
	INSTALL_FLAGS :=
else
	GO_C := gccgo-4.9 gccgo-go
	INSTALL_FLAGS := -gccgoflags=-static-libgo
endif

define DEPENDENCIES
  build-essential
  bzr
  git
  $(GO_C)
endef

default: build

$(GOPATH)/bin/godeps:
	go get -v github.com/rogpeppe/godeps

# Start of GOPATH-dependent targets. Some targets only make sense -
# and will only work - when this tree is found on the GOPATH.
ifeq ($(CURDIR),$(PROJECT_DIR))

build:
	go build $(PROJECT)/...

check:
	go test $(PROJECT)/...

install:
	go install $(INSTALL_FLAGS) -v $(PROJECT)/...

clean:
	go clean $(PROJECT)/...

else

build:
	$(error Cannot $@; $(CURDIR) is not on GOPATH)

check:
	$(error Cannot $@; $(CURDIR) is not on GOPATH)

install:
	$(error Cannot $@; $(CURDIR) is not on GOPATH)

clean:
	$(error Cannot $@; $(CURDIR) is not on GOPATH)

endif
# End of GOPATH-dependent targets.

# Reformat source files.
format:
	gofmt -w -l .

# Update the project Go dependencies to the required revision.
deps: $(GOPATH)/bin/godeps
	$(GOPATH)/bin/godeps -u dependencies.tsv

# Generate the dependencies file.
create-deps: $(GOPATH)/bin/godeps
	godeps -t $(shell go list $(PROJECT)/...) > dependencies.tsv || true

# Install packages required to develop the bundlechanges lib and run tests.
APT_BASED := $(shell command -v apt-get >/dev/null; echo $$?)
sysdeps:
ifeq ($(APT_BASED),0)
ifeq ($(shell lsb_release -cs|sed -r 's/precise|quantal|raring/old/'),old)
	@echo Adding PPAs for golang and mongodb
	@sudo apt-add-repository --yes ppa:juju/golang
	@sudo apt-add-repository --yes ppa:juju/stable
endif
	@echo Installing dependencies
	sudo apt-get update
	@sudo apt-get --yes install $(strip $(DEPENDENCIES)) \
	$(shell apt-cache madison juju-mongodb mongodb-server | head -1 | cut -d '|' -f1)
else
	@echo sysdeps runs only on systems with apt-get
	@echo on OS X with homebrew try: brew install bazaar mongodb
endif

help:
	@echo -e 'Juju Bundle Changes - list of make targets:\n'
	@echo 'make - Build the package.'
	@echo 'make check - Run tests.'
	@echo 'make install - Install the package.'
	@echo 'make clean - Remove object files from package source directories.'
	@echo 'make sysdeps - Install the development environment system packages.'
	@echo 'make deps - Set up the project Go dependencies.'
	@echo 'make create-deps - Generate the Go dependencies file.'
	@echo 'make format - Format the source files.'

.PHONY: build check clean format help install sysdeps

=== src/github.com/juju/description/Makefile ===
PROJECT := github.com/juju/description

.PHONY: check-licence check-go check

check: check-licence check-go
	go test $(PROJECT)/...

check-licence:
	@(fgrep -rl "Licensed under the LGPLv3" .;\
		fgrep -rl "MACHINE GENERATED BY THE COMMAND ABOVE; DO NOT EDIT" .;\
		find . -name "*.go") | sed -e 's,\./,,' | sort | uniq -u | \
		xargs -I {} echo FAIL: licence missed: {}

check-go:
	$(eval GOFMT := $(strip $(shell gofmt -l .| sed -e "s/^/ /g")))
	@(if [ x$(GOFMT) != x"" ]; then \
		echo go fmt is sad: $(GOFMT); \
		exit 1; \
	fi )
	@(go tool vet -all -composites=false -copylocks=false .)

=== src/github.com/juju/juju/Makefile ===
#
# Makefile for juju-core.
#
ifndef GOPATH
$(warning You need to set up a GOPATH.  See the README file.)
endif

PROJECT := github.com/juju/juju
PROJECT_DIR := $(shell go list -e -f '{{.Dir}}' $(PROJECT))

# Allow the tests to take longer on arm platforms.
ifeq ($(shell uname -p | sed -r 's/.*(armel|armhf|aarch64).*/golang/'), golang)
	TEST_TIMEOUT := 2400s
else
	TEST_TIMEOUT := 1500s
endif

# Enable verbose testing for reporting.
ifeq ($(VERBOSE_CHECK), 1)
	CHECK_ARGS = -v
else
	CHECK_ARGS =
endif

define DEPENDENCIES
  ca-certificates
  bzip2
  distro-info-data
  git
  zip
endef

default: build

# Start of GOPATH-dependent targets. Some targets only make sense -
# and will only work - when this tree is found on the GOPATH.
ifeq ($(CURDIR),$(PROJECT_DIR))

ifeq ($(JUJU_MAKE_GODEPS),true)
$(GOPATH)/bin/godeps:
	go get github.com/rogpeppe/godeps

godeps: $(GOPATH)/bin/godeps
	$(GOPATH)/bin/godeps -u dependencies.tsv
else
godeps:
	@echo "skipping godeps"
endif

build: godeps go-build

add-patches:
	cat $(PWD)/patches/*.diff | patch -f -u -p1 -r- -d $(PWD)/../../../

#this is useful to run after release-build, or as needed
remove-patches:
	cat $(PWD)/patches/*.diff | patch -f -R -u -p1 -r- -d $(PWD)/../../../

release-build: godeps add-patches go-build

release-install: godeps add-patches go-install remove-patches

check: godeps
	go test $(CHECK_ARGS) -test.timeout=$(TEST_TIMEOUT) $(PROJECT)/...

install: godeps go-install

clean:
	go clean $(PROJECT)/...

go-install:
	go install -v $(PROJECT)/...

go-build:
	go build $(PROJECT)/...

else # --------------------------------

build:
	$(error Cannot $@; $(CURDIR) is not on GOPATH)

check:
	$(error Cannot $@; $(CURDIR) is not on GOPATH)

install:
	$(error Cannot $@; $(CURDIR) is not on GOPATH)

clean:
	$(error Cannot $@; $(CURDIR) is not on GOPATH)

endif
# End of GOPATH-dependent targets.

# Reformat source files.
format:
	gofmt -w -l .

# Reformat and simplify source files.
simplify:
	gofmt -w -l -s .

rebuild-dependencies.tsv: godeps
	# godeps invoked this way includes 'github.com/juju/juju' as part of
	# the content, which we want to filter out.
	# '-t' is not needed on newer versions of godeps, but is still supported.
	godeps -t ./... | grep -v "^github.com/juju/juju\s" > dependencies.tsv

# Install packages required to develop Juju and run tests. The stable
# PPA includes the required mongodb-server binaries.
install-dependencies:
	@echo Installing go-1.10 snap
	@sudo snap install go --channel=1.10/stable --classic
	@echo Adding juju PPA for mongodb
	@sudo apt-add-repository --yes ppa:juju/stable
	@sudo apt-get update
	@echo Installing dependencies
	@sudo apt-get --yes install  \
	$(strip $(DEPENDENCIES)) \
	$(shell apt-cache madison juju-mongodb3.2 juju-mongodb mongodb-server | head -1 | cut -d '|' -f1)

# Install bash_completion
install-etc:
	@echo Installing bash completion
	@sudo install -o root -g root -m 644 etc/bash_completion.d/juju /usr/share/bash-completion/completions
	@sudo install -o root -g root -m 644 etc/bash_completion.d/juju-version /usr/share/bash-completion/completions

setup-lxd:
ifeq ($(shell ifconfig lxdbr0 2>&1 | grep -q "inet addr" && echo true),true)
	@echo IPv4 networking is already setup for LXD.
	@echo run "sudo scripts/setup-lxd.sh" to reconfigure IPv4 networking
else
	@echo Setting up IPv4 networking for LXD
	@sudo scripts/setup-lxd.sh || true
endif


GOCHECK_COUNT="$(shell go list -f '{{join .Deps "\n"}}' github.com/juju/juju/... | grep -c "gopkg.in/check.v*")"
check-deps:
	@echo "$(GOCHECK_COUNT) instances of gocheck not in test code"

.PHONY: build check install release-install release-build go-build go-install
.PHONY: clean format simplify
.PHONY: install-dependencies
.PHONY: rebuild-dependencies.tsv
.PHONY: check-deps
.PHONY: add-patches remove-patches

=== src/github.com/juju/pubsub/Makefile ===
default: check

check:
	go test

docs:
	godoc2md github.com/juju/pubsub > README.md
	sed -i 's|\[godoc-link-here\]|[![GoDoc](https://godoc.org/github.com/juju/pubsub?status.svg)](https://godoc.org/github.com/juju/pubsub)|' README.md


.PHONY: default check docs

=== src/github.com/juju/retry/Makefile ===
PROJECT := github.com/juju/retry

default: check

check-licence:
	@(fgrep -rl "Licensed under the LGPLv3" .;\
		fgrep -rl "MACHINE GENERATED BY THE COMMAND ABOVE; DO NOT EDIT" .;\
		find . -name "*.go") | sed -e 's,\./,,' | sort | uniq -u | \
		xargs -I {} echo FAIL: licence missed: {}

check: check-licence
	go test $(PROJECT)/...

docs:
	godoc2md $(PROJECT) > README.md

=== src/github.com/lxc/lxd/Makefile ===
DOMAIN=lxd
POFILES=$(wildcard po/*.po)
MOFILES=$(patsubst %.po,%.mo,$(POFILES))
LINGUAS=$(basename $(POFILES))
POTFILE=po/$(DOMAIN).pot

# dist is primarily for use when packaging; for development we still manage
# dependencies via `go get` explicitly.
# TODO: use git describe for versioning
VERSION=$(shell grep "var Version" shared/version/flex.go | cut -d'"' -f2)
ARCHIVE=lxd-$(VERSION).tar
TAGS=$(shell test -e /usr/include/sqlite3.h && echo "-tags libsqlite3")

.PHONY: default
default:
	# Must a few times due to go get race
	-go get -t -v -d ./...
	-go get -t -v -d ./...
	-go get -t -v -d ./...
	go install -v $(TAGS) $(DEBUG) ./...
	@echo "LXD built successfully"

.PHONY: client
client:
	# Must a few times due to go get race
	-go get -t -v -d ./...
	-go get -t -v -d ./...
	-go get -t -v -d ./...
	go install -v $(TAGS) $(DEBUG) ./lxc
	@echo "LXD client built successfully"

.PHONY: update
update:
	# Must a few times due to go get race
	-go get -t -v -d -u ./...
	-go get -t -v -d -u ./...
	go get -t -v -d -u ./...
	@echo "Dependencies updated"

# This only needs to be done when migrate.proto is actually changed; since we
# commit the .pb.go in the tree and it's not expected to change very often,
# it's not a default build step.
.PHONY: protobuf
protobuf:
	protoc --go_out=. ./lxd/migrate.proto

.PHONY: check
check: default
	go get -v -x github.com/rogpeppe/godeps
	go get -v -x github.com/remyoudompheng/go-misc/deadcode
	go get -v -x github.com/golang/lint/golint
	go test -v $(TAGS) $(DEBUG) ./...
	cd test && ./main.sh

gccgo:
	go build -v $(TAGS) $(DEBUG) -compiler gccgo ./...
	@echo "LXD built successfully with gccgo"

.PHONY: dist
dist:
	# Cleanup
	rm -Rf $(ARCHIVE).gz
	
	# Create build dir
	$(eval TMP := $(shell mktemp -d))
	git archive --prefix=lxd-$(VERSION)/ HEAD | tar -x -C $(TMP)
	mkdir -p $(TMP)/dist/src/github.com/lxc
	ln -s ../../../../lxd-$(VERSION) $(TMP)/dist/src/github.com/lxc/lxd
	
	# Download dependencies
	-cd $(TMP)/lxd-$(VERSION) && GOPATH=$(TMP)/dist go get -t -v -d ./...
	-cd $(TMP)/lxd-$(VERSION) && GOPATH=$(TMP)/dist go get -t -v -d ./...
	-cd $(TMP)/lxd-$(VERSION) && GOPATH=$(TMP)/dist go get -t -v -d ./...
	cd $(TMP)/lxd-$(VERSION) && GOPATH=$(TMP)/dist go get -t -v -d ./...
	
	# Assemble tarball
	rm $(TMP)/dist/src/github.com/lxc/lxd
	ln -s ../../../../ $(TMP)/dist/src/github.com/lxc/lxd
	mv $(TMP)/dist $(TMP)/lxd-$(VERSION)/
	tar --exclude-vcs -C $(TMP) -zcf $(ARCHIVE).gz lxd-$(VERSION)/
	
	# Cleanup
	rm -Rf $(TMP)

.PHONY: i18n update-po update-pot build-mo static-analysis
i18n: update-pot

po/%.mo: po/%.po
	msgfmt --statistics -o $@ $<

po/%.po: po/$(DOMAIN).pot
	msgmerge -U po/$*.po po/$(DOMAIN).pot

update-po:
	-for lang in $(LINGUAS); do\
	    msgmerge -U $$lang.po po/$(DOMAIN).pot; \
	    rm -f $$lang.po~; \
	done

update-pot:
	go get -v -x github.com/snapcore/snapd/i18n/xgettext-go/
	xgettext-go -o po/$(DOMAIN).pot --add-comments-tag=TRANSLATORS: --sort-output --package-name=$(DOMAIN) --msgid-bugs-address=lxc-devel@lists.linuxcontainers.org --keyword=i18n.G --keyword-plural=i18n.NG *.go shared/*.go lxc/*.go lxd/*.go

build-mo: $(MOFILES)

static-analysis:
	/bin/bash -x -c ". test/static_analysis.sh; static_analysis"

tags: *.go lxd/*.go shared/*.go lxc/*.go
	find . | grep \.go | grep -v git | grep -v .swp | grep -v vagrant | xargs gotags > tags

=== src/google.golang.org/api/google-api-go-generator/Makefile ===
# This Makefile is for library maintainers, not end-developers.
# All the generated code is already checked in.

API_JSON = $(wildcard ../*/*/*-api.json ../*/*/*/*-api.json)

GENERATOR=./google-api-go-generator

# Download all API specifications and rebuild Go bindings.
# All downloaded files are cached in $TMPDIR for reuse with 'cached' below.
all: $(GENERATOR)
	$(GENERATOR) -cache=false -install -api=*

# Reuse cached API specifications in $TMPDIR and rebuild Go bindings.
cached: $(GENERATOR)
	$(GENERATOR) -cache=true -install -api=*

# Only rebuild Go bindings, do not modify API specifications.
# For every existing */*/*-api.json file, */*/*-gen.go will be built.
local: $(API_JSON:-api.json=-gen.go)

# Pattern rule for the 'local' target.
# Translates otherwise unnamed targets with a -gen.go suffix into the
# matching input file with a -api.json suffix. $< is the input file.
%-gen.go: %-api.json $(GENERATOR)
	$(GENERATOR) -api_json_file=$<

# Alias to rebuild and install $(GENERATOR)
generator: $(GENERATOR)

# Marked as .PHONY so that make always invokes go build.
$(GENERATOR):
	go build -o $@

.PHONY: all cached local generator $(GENERATOR)

=== src/gopkg.in/juju/charmstore.v5-unstable/Makefile ===
# Makefile for the charm store.

ifndef GOPATH
$(warning You need to set up a GOPATH.)
endif

PROJECT := gopkg.in/juju/charmstore.v5-unstable
PROJECT_DIR := $(shell go list -e -f '{{.Dir}}' $(PROJECT))

GIT_COMMIT := $(shell git rev-parse --verify HEAD)
VERSION := $(shell git describe --dirty)


ifeq ($(shell uname -p | sed -r 's/.*(x86|armel|armhf).*/golang/'), golang)
	GO_C := golang
	INSTALL_FLAGS :=
else
	GO_C := gccgo-4.9 gccgo-go
	INSTALL_FLAGS := -gccgoflags=-static-libgo
endif

define DEPENDENCIES
  build-essential
  bzr
  juju-mongodb
  mongodb-server
  $(GO_C)
  openjdk-7-jre-headless
  elasticsearch
endef

ifeq ($(VERSION),no)
	VERSIONDEPS :=
else
	VERSIONDEPS := version/init.go
endif

default: build

$(GOPATH)/bin/godeps:
	# godeps needs to be fetched with the insecure flag as launchpad
	# uses http for part of the checkout process.
	go get -v -insecure launchpad.net/godeps

# Start of GOPATH-dependent targets. Some targets only make sense -
# and will only work - when this tree is found on the GOPATH.
ifeq ($(CURDIR),$(PROJECT_DIR))

build: $(VERSIONDEPS)
	go build $(PROJECT)/...

check: $(VERSIONDEPS)
	go test $(PROJECT)/...

install: $(VERSIONDEPS)
	go install $(INSTALL_FLAGS) -v $(PROJECT)/...

clean:
	go clean $(PROJECT)/...

else

build:
	$(error Cannot $@; $(CURDIR) is not on GOPATH)

check:
	$(error Cannot $@; $(CURDIR) is not on GOPATH)

install:
	$(error Cannot $@; $(CURDIR) is not on GOPATH)

clean:
	$(error Cannot $@; $(CURDIR) is not on GOPATH)

endif
# End of GOPATH-dependent targets.

# Reformat source files.
format:
	gofmt -w -l .

# Reformat and simplify source files.
simplify:
	gofmt -w -l -s .

# Run the charmd server.
server: install
	charmd -logging-config '<root>=DEBUG;mgo=INFO;bakery=INFO;httpbakery=INFO' cmd/charmd/config.yaml

# Update the project Go dependencies to the required revision.
deps: $(GOPATH)/bin/godeps
	$(GOPATH)/bin/godeps -u dependencies.tsv

# Generate the dependencies file.
create-deps: $(GOPATH)/bin/godeps
	godeps -t $(shell go list $(PROJECT)/...) > dependencies.tsv || true

# Generate version information
version/init.go: version/init.go.tmpl FORCE
	gofmt -r "unknownVersion -> Version{GitCommit: \"${GIT_COMMIT}\", Version: \"${VERSION}\",}" $< > $@

# Install packages required to develop the charm store and run tests.
APT_BASED := $(shell command -v apt-get >/dev/null; echo $$?)
sysdeps:
ifeq ($(APT_BASED),0)
ifeq ($(shell lsb_release -cs|sed -r 's/precise|quantal|raring/old/'),old)
	@echo Adding PPAs for golang and mongodb
	@sudo apt-add-repository --yes ppa:juju/golang
	@sudo apt-add-repository --yes ppa:juju/stable
endif
	@echo Installing dependencies
	[ "x$(apt-key export D88E42B4 2>&1 1>/dev/null)" = "x" ] || { curl -s http://packages.elasticsearch.org/GPG-KEY-elasticsearch | sudo apt-key add -;}
	repo="http://packages.elasticsearch.org/elasticsearch/1.3/debian" file=/etc/apt/sources.list.d/packages_elasticsearch_org_elasticsearch_1_3_debian.list ; grep "$$repo" $$file || echo "deb $$repo stable main" | sudo tee $$file > /dev/null
	sudo apt-get update
	@sudo apt-get --force-yes install $(strip $(DEPENDENCIES)) \
	$(shell apt-cache madison juju-mongodb mongodb-server | head -1 | cut -d '|' -f1)
else
	@echo sysdeps runs only on systems with apt-get
	@echo on OS X with homebrew try: brew install bazaar mongodb elasticsearch
endif

gopkg:
	@echo $(PROJECT)

help:
	@echo -e 'Charmstore - list of make targets:\n'
	@echo 'make - Build the package.'
	@echo 'make check - Run tests.'
	@echo 'make install - Install the package.'
	@echo 'make server - Start the charmd server.'
	@echo 'make clean - Remove object files from package source directories.'
	@echo 'make sysdeps - Install the development environment system packages.'
	@echo 'make deps - Set up the project Go dependencies.'
	@echo 'make create-deps - Generate the Go dependencies file.'
	@echo 'make format - Format the source files.'
	@echo 'make simplify - Format and simplify the source files.'
	@echo 'make gopkg - Output the current gopkg repository path and version.'

.PHONY: build check clean format gopkg help install simplify sysdeps FORCE

=== src/github.com/juju/juju/acceptancetests/Makefile ===
mkfile_dir := $(dir $(abspath $(lastword $(MAKEFILE_LIST))))
p=test*.py
py3="assess_model_change_watcher.py"
test:
	TMPDIR=/tmp python -m unittest discover -vv . -p "$(p)"
	TMPDIR=/tmp python3 -m unittest discover -vv jujupy -t . -p "$(p)"
lint:
	python3 -m flake8 --builtins xrange,basestring $(py3) --exclude=repository
	flake8 --builtins xrange,basestring --exclude=$(py3),repository
cover:
	python -m coverage run --source="./" --omit "./tests/*" -m unittest discover -vv ./tests
	python -m coverage report
clean:
	find . -name '*.pyc' -delete

apt-update:
	sudo apt-get -qq update
juju-ci-tools.common_0.1.4-0_all.deb: apt-update
	find . -name '*.deb' -delete
	sudo apt-get install -y equivs
	equivs-build juju-ci-tools-common
install-deps: juju-ci-tools.common_0.1.4-0_all.deb apt-update
	sudo dpkg -i juju-ci-tools.common_0.1.4-0_all.deb || true
	sudo apt-get install -y -f
	pip install --user -r $(mkfile_dir)/requirements.txt
name=NAMEHERE
assess_file=assess_$(name).py
new-assess:
	install -m 755 template_assess.py.tmpl $(assess_file)
	sed -i -e "s/TEMPLATE/$(name)/g" $(assess_file) $(test_assess_file)
.PHONY: lint test cover clean new-assess apt-update install-deps

=== src/github.com/juju/juju/acceptancetests/requirements.txt ===
apache-libcloud>=2.2.1
azure>=2.0.0rc3
azure-batch>=0.30.0rc3
azure-common>=1.1.3
azure-graphrbac>=0.30.0rc3
azure-mgmt>=0.30.0rc3
azure-mgmt-authorization>=0.30.0rc3
azure-mgmt-batch>=0.30.0rc3
azure-mgmt-cdn>=0.30.0rc3
azure-mgmt-compute>=0.30.0rc3
azure-mgmt-logic>=0.30.0rc3
azure-mgmt-network>=0.30.0rc3
azure-mgmt-notificationhubs>=0.30.0rc3
azure-mgmt-nspkg>=1.0.0
azure-mgmt-redis>=0.30.0rc3
azure-mgmt-resource>=0.30.0rc3
azure-mgmt-scheduler>=0.30.0rc3
azure-mgmt-storage>=0.30.0rc3
azure-mgmt-web>=0.30.0rc3
azure-nspkg>=1.0.0
azure-servicebus>=0.20.1
azure-servicemanagement-legacy>=0.20.3
azure-storage>=0.31.0
boto>=2.48
isodate>=0.5.1
msgpack-python>=0.4.6
msrestazure>=0.3.0
pywinrm>=0.0.3
pexpect>=2.4
xmltodict>=0.9.2
ipaddress>=1.0.16
python-novaclient>=6.0.2
pyOpenSSL>=17.5.0
boto3>=1.5.18

=== src/github.com/juju/juju/releasetests/Makefile ===
p=*.py
test:
	TMPDIR=/tmp python -m unittest discover -vv ./tests -p "$(p)"
lint:
	flake8 --max-line-length=80 $$(find . -name '*.py') \
	  --builtins=raw_input --ignore=E123,E402
cover:
	python -m coverage run --source="./" --omit "./tests/*" -m unittest discover -vv ./tests
	python -m coverage report
install-deps:
	sudo apt-get install \
	    python-mock python-tz python-testscenarios python-flake8 \
	    git bzr-builddeb mercurial golang \
	    python-boto python-swiftclient python-launchpadlib python-debian \
	    python-simplestreams innoextract zip
clean:
	find . -name '*.pyc' -delete
.PHONY: lint test cover clean

=== debian/changelog ===
juju-core (2.3.7-0ubuntu0.16.04.1) xenial; urgency=medium

  * New upstream release. (LP: #1766415)

 -- Christopher Lee <chris.lee@canonical.com>  Tue, 24 Apr 2018 11:27:26 -0400

juju-core (2.3.2-0ubuntu0.16.04.1) xenial; urgency=medium

  * New upstream release. (LP: #1744968)

 -- Nicholas Skaggs <nicholas.skaggs@canonical.com>  Fri, 26 Jan 2018 11:58:14 -0500

juju-core (2.3.1-0ubuntu0.16.04.1) xenial; urgency=medium

  * New upstream release. (LP: #1718213)

 -- Nicholas Skaggs <nicholas.skaggs@canonical.com>  Tue, 12 Dec 2017 14:41:40 -0500

juju-core (2.2.6-0ubuntu0.16.04.3) xenial; urgency=medium

  * Only juju 2.3+ supports cidr expansion for no proxy, fix for 2.2

 -- Nicholas Skaggs <nicholas.skaggs@canonical.com>  Thu, 16 Nov 2017 13:47:50 -0500

juju-core (2.2.6-0ubuntu0.16.04.2) xenial; urgency=medium

  * Add no_proxy for lxd subnet in support of adt tests

 -- Nicholas Skaggs <nicholas.skaggs@canonical.com>  Thu, 09 Nov 2017 11:24:07 -0500

juju-core (2.2.6-0ubuntu0.16.04.1) xenial; urgency=medium

  * New upstream release. (LP: #1718213)
  * Simplify use of embedded dependencies
  * Remove DH_VERBOSE=1
  * Ensure juju bootstrap succeeds with bionic in distro-info-data (LP: #1727355)

 -- Nicholas Skaggs <nicholas.skaggs@canonical.com>  Thu, 26 Oct 2017 14:49:02 -0400

juju-core (2.2.4-0ubuntu0.16.04.2) xenial; urgency=medium

  * Fix installation of bash completion scripts. 

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Wed, 25 Oct 2017 10:07:53 +1300

juju-core (2.2.4-0ubuntu0.16.04.1) xenial; urgency=medium

  * New upstream release. (LP: #1718213)
  * Remove debian/patches/CVE-2017-9232.patch, included upstream.
  * Improved support for mixing vendored and archive dependencies.
  * Killed old code for building on saucy, precise and with gccgo.
  * Embed Go 1.8.3 as upstream no longer builds with Go 1.6.
  * Switch golang.org/x/crypto dependency to vendorized.

 -- Michael Hudson-Doyle <mwhudson@debian.org>  Fri, 29 Sep 2017 10:01:07 -0400

juju-core (2.0.2-0ubuntu0.16.04.2) xenial-security; urgency=medium

  * SECURITY UPDATE: Privilege escalation via juju-run (LP: #1682411)
    - debian/patches/CVE-2017-9232.patch: create a unix domain socket with
      restricted permissions to limit juju-run to only similarly privileged
      processes.
    - CVE-2017-9232

 -- Seth Arnold <seth.arnold@canonical.com>  Thu, 25 May 2017 17:09:11 -0700

juju-core (2.0.2-0ubuntu0.16.04.1) xenial; urgency=medium

  * Backport upstream release 2.0.2 (LP: #1648894)
  * d/copyright Updated for 2.0.2 vendored packages

 -- Curtis C. Hovey <curtis@hovey.name>  Thu, 15 Dec 2016 18:07:37 +0000

juju-core (2.0.0-0ubuntu0.16.04.2) xenial; urgency=medium

  * DPKG_MAINTSCRIPT_ARCH doesn't work in .config, use dpkg check (LP: #1614969)

 -- Nicholas Skaggs <nicholas.skaggs@canonical.com>  Mon, 31 Oct 2016 15:55:49 -0400

juju-core (2.0.0-0ubuntu0.16.04.1) xenial-proposed; urgency=medium

  [ Nicholas Skaggs ]
  * New upstream release 2.0.0 (LP: #1617440)
  * Disable future manual provider test (LP: #1629376)
  * Add sysctl files for lxd provider (LP: #1631038)
  * Juju can interact with LXD > 2.0 (LP: #1614559) 
  * Change LXD to depends to ensure autopkgtest run on LXD upload (LP: #1614724)
  * d/copyright updated for 2.0.0 vendored packages.
  * Update bootstrap order for autpopkgtests for juju cli changes
  * Display debconf note upon install or upgrade for unsupported architectures
  * Skip autopkgtests on unsupported arches
  * Fix lxd-provider test to utilize *_proxy settings and provide additional info
  * Add template and config files for debconf messaging
  * Remove all quilt patches
  * Add upstream signing key
  * Update watch file to point to lp.net/juju to reflect project move
  * Add po-debconf dependency for template translation support

  [ Mathieu Trudel-Lapierre ]
  * debian/*.postinst: use DPKG_MAINTSCRIPT_ARCH to detect architectures
  * debian/control: Depends on golang-golang-x-crypto-dev 
    (>= 1:0.0~git20161012.0.5f3178)

  [Curtis Hovey]
  * d/t/setup-lxd.sh support lxd 2.0 and 2.3 network configuration in tests

 -- Nicholas Skaggs <nicholas.skaggs@canonical.com>  Thu, 20 Oct 2016 15:28:12 +0200

juju-core (2.0~beta15-0ubuntu2.16.04.1) xenial-proposed; urgency=medium

  * Restore all arches to building
  * Apply patch for powerpc build 
  * Re-add jujud to package (LP: #1608538)

 -- Nicholas Skaggs <nicholas.skaggs@canonical.com>  Fri, 18 Aug 2016 10:08:34 -0400

juju-core (2.0~beta15-0ubuntu1.16.04.1) xenial-proposed; urgency=medium

  * New upstream release 2.0-beta15 (LP: #1613718)
  * Update debian/copyright
  * Re-enable current-manual-provider test
  * Remove jujud from package
  * Remove golang-juju-loggo-dev dependency temporarily (LP: #1612713)

 -- Nicholas Skaggs <nicholas.skaggs@canonical.com>  Fri, 12 Aug 2016 10:08:34 -0400

=== debian/control ===
Source: juju-core
Section: devel
Priority: extra
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
Build-Depends: debhelper (>= 9),
               dh-golang,
               distro-info,
               golang-github-bmizerany-pat-dev,
               golang-go (>= 2:1.6),
               golang-go-dbus-dev,
               golang-gopkg-tomb.v2-dev,
               lsb-release,
               po-debconf,
               python
Standards-Version: 3.9.7
Homepage: http://launchpad.net/juju-core
Xs-Go-Import-Path: github.com/juju/juju
Testsuite: autopkgtest

Package: juju-2.0
Architecture: any
Depends: distro-info, lxd, ${misc:Depends}, ${shlibs:Depends}
Recommends: bash-completion
Breaks: juju-core (<= 1.25.4)
Conflicts: juju2, juju-core2
Replaces: juju2, juju-core2
Built-Using: ${misc:Built-Using}
Description: Juju is devops distilled - client
 Through the use of charms, juju provides you with shareable, re-usable,
 and repeatable expressions of devops best practices. You can use them
 unmodified, or easily change and connect them to fit your needs. Deploying
 a charm is similar to installing a package on Ubuntu: ask for it and
 it’s there, remove it and it’s completely gone.
 .
 This package provides the client application of creating and interacting
 with Juju environments.

Package: juju
Architecture: all
Depends: juju-2.0 (>= ${source:Version}), ${misc:Depends}
Suggests: juju-core
Description: next generation service orchestration system
 Through the use of charms, juju provides you with shareable, re-usable,
 and repeatable expressions of devops best practices. You can use them
 unmodified, or easily change and connect them to fit your needs. Deploying
 a charm is similar to installing a package on Ubuntu: ask for it and
 it’s there, remove it and it’s completely gone.
 .
 This is a dependency package providing the current version of Juju.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

#export DH_VERBOSE=1

GODIR=go

export DH_GOPKG:=github.com/juju/juju
export BUILDPATH := obj-$(DEB_BUILD_GNU_TYPE)
export GOPATH := $(CURDIR)/$(BUILDPATH)
export PATH:=$(CURDIR)/$(GODIR)/bin:$(GOPATH)/bin:$(PATH)

PKGDIR:=debian/juju
VERSION:=$(shell sed -n 's/^const version = "\(2\.[0-9]\+\)[\.-].*"/\1/p' $(CURDIR)/src/github.com/juju/juju/version/version.go)
ifeq ($(VERSION),)
$(error Invalid version constant in version.go)
endif

DB_DEP = -Vdist:Depends="juju-mongodb (>= 2.4.6)"

%:
	dh $@ --with=golang --buildsystem=golang

COMMON_FLAGS:= -v
supported_archs:= amd64 s390x ppc64el arm64

build_go:
ifneq (,$(filter $(DEB_HOST_ARCH), $(supported_archs)))
	cd $(GODIR)/src && \
	GOROOT_BOOTSTRAP=$$(/usr/bin/go env GOROOT) ./make.bash
else
	:
endif

# Ugly workaround for bundled dependencies
# This is inspiried by LXD's packaging
override_dh_auto_configure: build_go
	dh_auto_configure

	# dh-golang's configure has copied the source tree into GOPATH. But
	# because juju gets some dependencies from the archive and some from
	# the copies bundled in dist, we have to unpick a bunch of what it has
	# done and set it up again.

	# Remove the extra copy of src dh-golang has copied onto GOPATH (or
	# when dh-golang tries to run go install github.com/juju/juju/... things
	# get very confused).

	# Move the juju source aside while we do this.
	mv ${GOPATH}/src/github.com/juju/juju/src/github.com/juju/juju ${GOPATH}/juju

	# Clean GOPATH.
	rm -Rf ${GOPATH}/src

	# copy dependencies from GOPATH.
	cp -R src ${GOPATH}

	# But not the symlink for juju.
	rm -rf ${GOPATH}/src/github.com/juju/juju

	# Link depedencies from where the distro package
	# has installed it, as appropriate.
	# Packaged dependencies
	debian/helpers/link-from-installed github.com/bmizerany/pat
	debian/helpers/link-from-installed launchpad.net/go-dbus
	debian/helpers/link-from-installed gopkg.in/tomb.v2

	# And put the juju source back again.
	mkdir -p ${GOPATH}/src/github.com/juju/
	mv ${GOPATH}/juju/ ${GOPATH}/src/github.com/juju/juju/

override_dh_auto_build:
ifneq (,$(filter $(DEB_HOST_ARCH), $(supported_archs)))
		dh_auto_build -- $(COMMON_FLAGS)
endif

# Don't run the tests -- the juju unit tests are too heavyweight to run during
# package build.
override_dh_auto_test:
	:

override_dh_auto_install:
ifneq (,$(filter $(DEB_HOST_ARCH), $(supported_archs)))
	echo '#!/bin/sh\nexport PATH=/usr/lib/juju-$(VERSION)/bin:"$$PATH"\nexec juju "$$@"' > ${BUILDPATH}/bin/juju-$(VERSION)
	chmod 755 ${BUILDPATH}/bin/juju-$(VERSION)
	mkdir -p ${BUILDPATH}/home
	HOME=${BUILDPATH}/home $(CURDIR)/src/github.com/juju/juju/scripts/generate-docs.py man -o ${BUILDPATH}/juju.1
	dh_install ${BUILDPATH}/bin/juju usr/lib/juju-$(VERSION)/bin
	dh_install ${BUILDPATH}/bin/juju-metadata usr/lib/juju-$(VERSION)/bin
	dh_install ${BUILDPATH}/bin/jujud usr/lib/juju-$(VERSION)/bin
	dh_install ${BUILDPATH}/bin/juju-$(VERSION) usr/bin
	dh_install ${BUILDPATH}/juju.1 usr/lib/juju-$(VERSION)/man/man1
	# Install bash completion scripts
	dh_install src/github.com/juju/juju/etc/bash_completion.d/juju-version \
	           usr/share/bash-completion/completions
	dh_install src/github.com/juju/juju/etc/bash_completion.d/juju \
	           usr/share/bash-completion/completions
	dh_install debian/juju-2.conf usr/lib/sysctl.d
endif

override_dh_link:
	dh_link -pjuju-2.0 usr/bin/juju-$(VERSION) usr/bin/juju
	dh_link -pjuju-2.0 usr/lib/juju-$(VERSION)/man/man1/juju.1.gz usr/share/man/man1/juju.1.gz
	dh_link -pjuju-2.0 usr/lib/juju-$(VERSION)/man/man1/juju.1.gz usr/share/man/man1/juju-$(VERSION).1.gz
	dh_link

override_dh_compress:
ifneq (,$(filter $(DEB_HOST_ARCH), $(supported_archs)))
	dh_compress usr/lib/juju-$(VERSION)/man/man1/juju.1
endif
	dh_compress

override_dh_auto_clean:
	find . -name "*.pyc" -delete || :
	dh_auto_clean

override_dh_builddeb:
	dh_builddeb -- -Zxz

override_dh_gencontrol:
	dh_gencontrol -- $(DB_DEP)

=== debian/watch ===
version=3
opts="uversionmangle=s/^1://;s/-/~/" \
 https://launchpad.net/juju/+download https://launchpad.net/juju/.*/.*/.*/juju-core_(.*)\.tar\.gz
opts=pgpsigurlmangle=s/$/.asc/ \
 https://launchpad.net/juju/+download https://launchpad.net/juju/.*/.*/.*/juju-core_(.*)\.tar\.gz
